const app = require('../../utils/util.js');
const tools = require('../../utils/tools.js');
Page({
  data: {
    lbArr: [],
    showNull: false,
    sfmArr: []
  },
  goIn(e) {
    let id = e.currentTarget.dataset.item.id
    wx.navigateTo({
      url: '../dbDetails/dbDetails?id=' + id
    })
  },
  getArr(sessionKey) {
    // let _this = this;
    wx.request({
      url: app.globalData.publicUrl + '/wx/course/selectRecordBySessionKey',
      method: "post",
      data: {
        sessionKey: sessionKey
      },
      success: (res) => {
        console.log(res, "lb")
        if (res.data.code == 0) {
          console.log(res)
          this.setData({
            lbArr: res.data.list
          })
          let result = [];
          for (let i = 0; i < res.data.list.length; i++) {
            result.push({
              courseTime: res.data.list[i].courseTime
            });
          }
          const timesArr = result.map((item) => {
            return item.courseTime;
          });
          let sfmArr = [];
          for (let i = 0; i < timesArr.length; i++) {
            let value = timesArr[i];
            const resultValue = this.handler(value);
            sfmArr.push({
              courseTime: resultValue
            })
            this.setData({
              sfmArr: sfmArr
            })
          }
          if (this.data.lbArr.length == 0) {
            this.setData({
              showNull: true
            })
          }
        } else {
          if (this.data.lbArr.length == 0) {
            this.setData({
              showNull: true
            })
          }
        }
      },
      fail: () => {
        if (this.data.lbArr.length == 0) {
          this.setData({
            showNull: true
          })
        }
      }
    })
  },
  handler(value) {
    //换算为秒 进制1000
    const second = Math.floor(value / 1000); //判断是否够1秒
    if (second < 1) {
      return "0秒";
    }
    const secondValue = second % 60; // 秒
    const minutes = Math.floor(second / 60); //判断是否够1分钟
    if (minutes < 1) {
      return `${secondValue}秒`;
    }
    const minutesValue = minutes % 60; //分
    const hours = Math.floor(minutes / 60); //判断是否够1小时
    if (hours < 1) {
      return `${minutesValue}分${secondValue}秒`;
    }
    const hoursValue = hours % 60; //小时
    return `${hoursValue}时${minutesValue}分${secondValue}秒`;
  },
  async onLoad() {
    const sessionKey = await tools.checkSessionAndLogin();
    this.getArr(sessionKey)
  }
})