const app = require('../../utils/util.js');
const tools = require('../../utils/tools.js');
Page({
  data: {
    isshow1: false,
    isshow2: true,
    activebg: "#ffeae9",
    unactivebg: "#f2f2f2",
    mytip: "",
    listArr: []
  },
  // tab1
  tab1Show() {
    this.setData({
      isshow1: false,
      isshow2: true,
      activebg: "#ffeae9",
      unactivebg: "#f2f2f2"
    })
  },
  //tab2
  async tab2Show() {
    const sessionKey = await tools.checkSessionAndLogin();
    wx.request({
      url: app.globalData.publicUrl + '/wx/board/list',
      method: "post",
      data: {
        sessionKey: sessionKey
      },
      success: (res) => {
        console.log(res, "我是查到的列表")
        if (res.data.code == 0) {
          if (res.data.list.length == 0) {
            wx.showModal({
              showCancel: false,
              content: "您还没有提问哦"
            })
          } else {
            this.setData({
              listArr: res.data.list,
              isshow1: true,
              isshow2: false,
              activebg: "#f2f2f2",
              unactivebg: "#ffeae9"
            })
          }
        } else {
          wx.showModal({
            showCancel: false,
            content: "您还没有提问哦"
          })
        }
      }
    })
  },
  // 去解答的详情页
  gojjDetails(e) {
    let id = e.currentTarget.dataset.item.id
    if (e.currentTarget.dataset.item.replyContent == "" || e.currentTarget.dataset.item.replyContent == null) {
      wx.showModal({
        showCancel: false,
        content: "您还没收到回复哦"
      })
    } else {
      wx.navigateTo({
        url: '/pages/myInteractionsDetais/myInteractionsDetais?id=' + id,
      })
    }

  },
  async bindFormSubmit(e) {
    let input_val = e.detail.value.textarea;
    const sessionKey = await tools.checkSessionAndLogin();
    if (input_val == "" || input_val == undefined) {
      wx.showToast({
        title: '反馈不能为空',
        icon: 'none',
        duration: 1000
      })
      return false;
    }
    wx.showLoading({
      mask: true,
      title: '加载中',
    })
    wx.request({
      url: app.globalData.publicUrl + '/wx/board/add',
      method: "post",
      data: {
        content: input_val,
        sessionKey: sessionKey
      },
      success: (res) => {
        wx.hideLoading()
        if (res.data.code == 0) {
          wx.showModal({
            showCancel: false,
            content: "提交成功",
            success: (res) => {
              if (res.confirm) {
                this.setData({
                  mytip: ""
                })
              }
            }
          })
        } else {
          wx.showModal({
            showCancel: false,
            content: res.data.msg
          })
        }
      }
    })
  }
})