const tools = require('../../utils/tools.js');
const app = require('../../utils/util.js');
Page({
  data: {
    active: 0,
    zbArr: [],
    showNull: false
  },
  goIn(e) {
    let id = e.currentTarget.dataset.item.id
    if (e.currentTarget.dataset.item.isActive == 1) {
      wx.navigateTo({
        url: '../zbDetails/zbDetails?id=' + id
      })
    } else {
      wx.showModal({
        showCancel: false,
        content: "直播还未开始哦"
      })
    }
  },
  getArr(sessionKey) {
    wx.request({
      url: app.globalData.publicUrl + '/wx/course/selectLivesBySessionKey',
      method: "post",
      data: {
        sessionKey: sessionKey
      },
      success: (res) => {
        if (res.data.code == 0) {
          this.setData({
            zbArr: res.data.list
          })
          if (res.data.list.length == 0) {
            this.setData({
              showNull: true
            })
          }
        } else {
          if (this.data.zbArr.length == 0) {
            this.setData({
              showNull: true
            })
          }
        }
      },
      fail: () => {
        if (this.data.zbArr.length == 0) {
          this.setData({
            showNull: true
          })
        }
      }
    })
  },
  async onLoad() {
    const sessionKey = await tools.checkSessionAndLogin();
    this.getArr(sessionKey);
  }
})